package com.up.ti;

import java.io.*;

public class PictureFile extends TIVariableFile {
    public int[][] pixeldata = new int[96][64];
    private int[] picdata = new int[768];
    public int picnum = 1;
    
    /**
     Saves the file to <tt>name</tt> using the current token string, comment, and TI name.
     @param name Name of the file to write
     */
    public void saveFile(String name) {
	int p = 0;
	for (int x = 0; x < 768; x++) {
	    int tempbyte = 0;
	    for (int y = 7; y >= 0; y--) {
		tempbyte += pixeldata[p % 96][p / 96] << y;
		p++;
	    }
	    picdata[x] = tempbyte;
	}
	int length = 768;
	setSize(length + 19);
	setByte(0, 13);
	setByte(1, 0);
	setByte(2, (length + 2) % 256);
	setByte(3, (length + 2) / 256);
	setByte(4, 7);
	setByte(5, 0x60);
	setByte(6, picnum - 1);
	setByte(13, 0);
	setByte(14, 0);
	setByte(15, (length + 2) % 256);
	setByte(16, (length + 2) / 256);
	setByte(17, length % 256);
	setByte(18, length / 256);
	for (int x = 0; x < picdata.length; x++) {
	    setByte(19 + x, picdata[x]);
	}
	writeFile(name);
    }

    /**
     Opens the file <tt>name</tt> and saves the data in .
     @param name Name of the file to read
     */
    public void openFile(String name) throws FileNotFoundException {
	readFile(name);
	picnum = getData()[6] + 1;
	picdata = new int[getData().length - 19];
	System.arraycopy(convert(getData()), 19, picdata, 0, getData().length - 19);
	int p = 0;
	for (int x = 0; x < getData().length - 19; x++) {
	    for (int y = 7; y >= 0; y--) {
		pixeldata[p % 96][p / 96] = (picdata[x] & (1 << y)) >> y;
		p++;
	    }
	}
	picdata = (int[])Util.resizeArray(picdata, 768);
    }

    /**
     Opens the file <tt>name</tt> and saves the data in .
     @param file InputStream of the file to read
     */
    public void openFile(InputStream file) throws FileNotFoundException {
	readFile(file);
	picnum = getData()[6];
	picdata = new int[getData().length - 19];
	System.arraycopy(getData(), 19, picdata, 0, getData().length - 19);
	int p = 0;
	for (int x = 0; x < 768; x++) {
	    for (int y = 7; y >= 0; y--) {
		pixeldata[p % 96][p / 96] = (picdata[x] & (1 << y)) >> y;
		p++;
	    }
	}
	picdata = (int[])Util.resizeArray(picdata, 768);
    }
    private int[] convert(short[] s) {
	int[] i = new int[s.length];
	for (int x = 0; x < s.length; x++) {
	    i[x] = (int)s[x]; // convert any way you like
	}
	return i;
    }
}
