package com.up.ti;

import com.up.ti.data.TokenSet;
import java.io.*;

/**
 * A 
 * @author Ricky
 */
public class ProgramFile extends TIVariableFile {
    public String Tokens;
    private String Name;
    public boolean isAxe;
    public boolean isVar = false;
    public int length = 3;
    public TokenSet ts;

    public ProgramFile() {
	setName("DEFAULT");
        ts = new TokenSet();
    }

    /**
     Saves the file to <tt>name</tt> using the current token string, comment, and TI name.
     @param name Name of the file to write
     */
    public void saveFile(String name) {
	short[] tmp = ts.stringToData(Tokens);
	length = tmp.length;
	setSize(length + 19);
	setByte(0, 13);
	setByte(1, 0);
	setByte(2, (length + 2) % 256);
	setByte(3, (length + 2) / 256);
	setByte(4, 5 + (isVar ? 16 : 0));
	for (int x = 0; x < 8; x++) {
	    setByte(5 + x, Name.charAt(x));
	}
	setByte(13, 0);
	setByte(14, 0);
	setByte(15, (length + 2) % 256);
	setByte(16, (length + 2) / 256);
	setByte(17, length % 256);
	setByte(18, length / 256);
	for (int x = 0; x < tmp.length; x++) {
	    setByte(19 + x, tmp[x]);
	}
	writeFile(name);
    }

    /**
     Opens the file <tt>name</tt> and saves the data in .
     @param name Name of the file to read
     */
    public void openFile(String name) throws FileNotFoundException {
	readFile(name);
	Name = "";
	for (int x = 0; x < 8; x++) {
	    Name += Character.toString((char)getData()[5 + x]);
	}
	short[] tokendata = new short[getData().length - 19];
	System.arraycopy(getData(), 19, tokendata, 0, getData().length - 19);
	Tokens = ts.dataToString(tokendata);
	isAxe = Tokens.substring(0, 1).equals(".");
    }

    /**
     Opens the file <tt>name</tt> and saves the data in .
     @param file InputStream of the file to read
     */
    public void openFile(InputStream file) throws FileNotFoundException {
	readFile(file);
	Name = "";
	for (int x = 0; x < 8; x++) {
	    Name += Character.toString((char)getData()[5 + x]);
	}
	short[] tokendata = new short[getData().length - 19];
	System.arraycopy(getData(), 19, tokendata, 0, getData().length - 19);
	Tokens = ts.dataToString(tokendata);
	isAxe = Tokens.substring(0, 1).equals(".");
    }

    /**

     @param name
     */
    public void setName(String name) {
	if (name.length() < 8) {
	    name = Util.padRight(name, 8, (char)0);
	} else if (name.length() > 8) {
	    name = name.substring(0, 7);
	}
	Name = name;
    }

    /**

     @return
     */
    public String getName() {
	return Name;
    }
}